
/*
 * $Id: BcastChannel.cc,v 1.3 1999/09/07 17:45:59 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "Clock.h"
#include "BcastChannel.h"

bool BcastChannel::Debug = false;

BcastChannel::BcastChannel(const String &anName): theName(anName) {
}

void BcastChannel::subscribe(BcastRcver* rcver) {
	int idx;
	if (!find(rcver, idx))
		append(rcver);
}

void BcastChannel::unsubscribe(BcastRcver* rcver) {
	int idx;
	if (find(rcver, idx)) {
		// move to the tail and pop
		swap(idx, count()-1);
		pop();
	}
}

void BcastChannel::showEvent() const {
	clog << TheClock << " event: " << theName << " x " << theCount << endl;
}
