
/*
 * $Id: EphPortMgr.cc,v 1.4 1999/09/22 21:59:46 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "Socket.h"
#include "EphPortMgr.h"


EphPortMgr::EphPortMgr(const NetAddr &anAddr): PortMgr(anAddr) {
	theAddr.port(0);
}

int EphPortMgr::allocPort(Socket &s) {
	if (s.bind(theAddr))
		return s.lport();
	return -1;
}

void EphPortMgr::freePort(int, bool) {
}
