
/*
 * $Id: LogComment.cc,v 1.4 1999/09/17 23:54:13 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "Clock.h"
#include "LogComment.h"
#include "PolyOLog.h"
#include "polyLogTags.h"
#include "gadgets.h"
#include "globals.h"

int LogComment::TheEchoLevel = 0;
int LogComment::TheCurLevel = 0;
char LogComment::TheBuf[8*1024];

LogComment Comment; // note: assumes Comment is not used in static-ctors

LogComment::LogComment(): ostrstream(TheBuf, sizeof(TheBuf)) {
	configureStream(*this, 2);
}

ostream &endc(ostream &os) {
	os << ends;
	TheOLog << bege(lgComment) << Comment.str() << ende;
	if (Comment.TheCurLevel <= Comment.TheEchoLevel) {
		cout 
			<< setfill('0') << setw(6) << (TheClock.runTime().secd()/60)
			<< setfill(' ')	<< "| "
			<< Comment.str() << endl;
	}
	Comment.reset();
	return os; 
}
