
/*
 * $Id: Tuner.cc,v 1.3 1999/09/07 17:46:32 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "Tuner.h"

Tuner::Tuner(): theSensy(-1), theReact(-1), 
	theTarget(0), theInput(0), theOutput(0),
	theWin(-1), theCnt(0), theAcc(0) {
}

void Tuner::target(double aTarget) {
	// start from the very beginning
	theTarget = theInput = theOutput = aTarget;
	theAcc = theCnt = 0;
}

void Tuner::syncInput(double or) {
	Assert(theWin >= 0 && theSensy >= 0 && theReact >= 0); // must be set

	theOutput *= 1 - theSensy;
	theOutput += theSensy*or;

	theInput += (theTarget - theOutput)*theReact;

	theAcc = theCnt = 0; // reset
}
