
/*
 * $Id: CltConnMgr.h,v 1.8.2.2 1999/10/05 19:58:59 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CLIENT_CONNECTION_MANAGER_H
#define PG_CLIENT_CONNECTION_MANAGER_H

#include "NetAddr.h"
#include "Queue.h"
#include "ConnHash.h"
#include "ConnMgr.h"

class PortMgr;

class CltConnMgr: public ConnMgr {
	public:
		CltConnMgr();
		virtual ~CltConnMgr();

		void configure(const SockOpt &anOpt, RndDistr *aPconnUseLmt, int aConnLvlLmt, int srvCnt);
		void portMgr(PortMgr *aPortMgr);

		bool atHardConnLimit() const; 
		virtual Connection *get(const NetAddr &addr);

		virtual void noteReadReady(int fd);

	protected:
		Connection *open(const NetAddr &addr);
		virtual void putIdle(Connection *conn);
		void closeIdle(Connection *conn, ConnCloseStat::CloseKind ck);

	protected:
		ConnHash theIdleHash;
		Queue<Connection> theIdleQueue;
		PortMgr *thePortMgr;

		int theConnLvlLmt;  // limit for opened connections
};

#endif
