
/*
 * $Id: ContBuildIter.h,v 1.3.2.1 1999/10/25 19:17:38 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CONTENT_BUILD_ITERATOR_H
#define PG_CONTENT_BUILD_ITERATOR_H

#include "Rnd.h"

class WrBuf;
class EmbedContMdl;

class ContBuildIter {
	public:
		ContBuildIter();

		void configure(EmbedContMdl *aModel, WrBuf *aBuf, Size aSize);
		void oid(int anOid, int aSeed);
		void reset();

		int embedCount() const { return theEmbedCount; }

		void slice(); // fills the buffer

	protected:
		Size embed(); // writes embedded oid tag

	protected:
		EmbedContMdl *theModel;
		WrBuf *theBuf;
		int theOid;
		RndGen theRng;
		Size theContSize;
		Size theBuiltSize;

		int theEmbedGoal;     // how many objects to embed
		int theEmbedCount;    // number of objects embedded so far
		int theNewEmbedCount; // new embedded objects produced so far
		Size theEmbedDist;    // ~ distance between embed tags
};

#endif
