
/*
 * $Id: ContentCfg.h,v 1.4.2.2 1999/10/25 23:25:15 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CONTENT_CONFIGURATION_H
#define PG_CONTENT_CONFIGURATION_H

#include "String.h"
#include "ObjLifeCycle.h"

class RndDistr;
class ContentSym;
class EmbedContMdl;

class ContentCfg {
	public:
		ContentCfg(int anId);

		void configure(const ContentSym *cfg);

		int id() const { return theId; }
		const String &kind() const { return theKind; }
		double newPerOid() const { return theNewPerOid; }

		double compContPerCall(const ContentCfg *cc) const;
		void noteNewContProb(ContentCfg *cc, double newProb);
		void newPerOid(double aNewPerOid);

	public:
		String theKind;
		String theMimeType;
		RndDistr *theSize;
		ObjLifeCycle theObjLifeCycle;
		double theChbRatio;

		EmbedContMdl *theEmbedCont;

	protected:
		double theNewPerOid; // new content oids per direct access oid
		int theId;
};

#endif
