
/*
 * $Id: SrvConnMgr.h,v 1.5.6.2 1999/11/28 22:25:03 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_SERVER_CONNECTION_MANAGER_H
#define PG_SERVER_CONNECTION_MANAGER_H

#include "ConnMgr.h"

class SrvConnMgr: public ConnMgr {
	public:
		class User {
			public:
				virtual ~User() {}
				virtual void noteConnReady(Connection *conn) = 0;
		};

	public:
		SrvConnMgr(User *aUser);

		void acceptLmt(int aLmt);

		bool accept(Socket &s); // false iff fatal error

		virtual void noteReadReady(int fd);
		
	protected:
		virtual void putIdle(Connection *conn);

	protected:
		User *theUser;
		int theAcceptLmt;
};

#endif
