
/*
 * $Id: DumperSym.cc,v 1.2 1999/09/07 17:47:37 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "String.h"
#include "PglRec.h"
#include "DumperSym.h"


DumperSym::DumperSym(): RecSym("Dumper", new PglRec) {

	// add fields

	theRec->bAdd("bool", "req_hdrs", 0);
	theRec->bAdd("bool", "rep_hdrs", 0);
}

DumperSym::DumperSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool DumperSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "Dumper";
}

SynSym *DumperSym::clone(const String &type) const {
	if (isA(type))
		return new DumperSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}
