
/*
 * $Id: PglStringSym.cc,v 1.4 1999/09/07 17:47:50 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "PglStringSym.h"


bool StringSym::isA(const String &type) const {
	return ExpressionSym::isA(type) ||
		type == "String" || type == "string";
}

SynSym *StringSym::clone(const String &type) const {
	if (isA(type))
		return new StringSym(theVal);
	return ExpressionSym::clone(type);
}

ostream &StringSym::print(ostream &os, const String &) const {
	return os << '"' << theVal << '"';
}
