
/*
 * $Id: GoalSym.h,v 1.5 1999/09/07 17:47:58 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_GOAL_CONFIGURATION_SYMBOL_H
#define PGL_GOAL_CONFIGURATION_SYMBOL_H

#include "Time.h"
#include "PglRecSym.h"

class BigSize;

// run goal specification
class GoalSym: public RecSym {
	public:
		GoalSym();
		GoalSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		Time duration() const;
		bool xactCount(int &count) const;
		bool fillSize(BigSize &sz) const;
		bool errs(double &ratio, int &count) const;
};

#endif
