
/*
 * $Id: PglCtx.h,v 1.3 1999/09/07 17:48:01 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef POLYGRAPH_PGL_CONTEXT_H
#define POLYGRAPH_PGL_CONTEXT_H

#include "SynSymTbl.h"

// holds current parsing context
// contexts can be nested
// contexts may be "named" (equivalent to "using" clause in Pascal)
class PglCtx: public SynSymTbl {
	public:
		static PglCtx *RootCtx() { return TheRootCtx; }

	public:
		PglCtx(const String &aName, PglCtx *aParent = 0);
		virtual ~PglCtx();

		PglCtx *parent() { return theParent; }
		const String &name() const { return theName; }
		int nestDepth() const;

		virtual SynSymTblItem **valp(const String &key);

		virtual void report(ostream &os, const String &) const;

	protected:
		// recusrsive search
		SynSymTblItem **valpR(const String &key);
		// search for a.b
		SynSymTblItem **memberp(const String &name);

		virtual void noteAdd(int idx);
		virtual void noteDel(int idx);

	protected:
		static PglCtx *TheRootCtx; // root context

	protected:
		String theName;
		PglCtx *theParent; // null for root context
};

#endif
