
/*
 * $Id: PglNetAddrSym.h,v 1.5.6.1 1999/09/30 19:38:48 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_NETWORK_ADDRESS_SYMBOL_H
#define PGL_NETWORK_ADDRESS_SYMBOL_H

#include "PglRecSym.h"
#include "NetAddr.h"

class SynSymTblItem;
class StringSym;
class String;

// host:port network address

class NetAddrSym: public RecSym {
	public:
		NetAddrSym();
		NetAddrSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *bnOper(const String &op, const SynSym &s) const;

		NetAddr val() const;
		void val(const NetAddr &addr);

		virtual ostream &print(ostream &os, const String &pfx) const;
};

#endif
