
/*
 * $Id: RobotSym.h,v 1.6.2.5 1999/10/13 17:26:57 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_ROBOT_SYMBOL_H
#define PG_ROBOT_SYMBOL_H

#include "Array.h"
#include "AgentSym.h"

class PopModel;

// server side configuration
class RobotSym: public AgentSym {
	public:
		RobotSym();
		RobotSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		bool reqRate(double &rate) const;
		bool origins(Array<NetAddr*> &addrs, RndDistr *&sel) const;
		bool cacheCap(int &cap) const;
		bool publicRatio(double &ratio) const;
		bool recurRatio(double &ratio) const;
		bool embedRecurRatio(double &ratio) const;
		PopModel *popModel() const;
		bool uniqueUrls(bool &set) const;
		Time launchWin() const;
		bool openConnLimit(int &lmt) const;
		bool waitXactLimit(int &lmt) const;
};

#endif
