
/*
 * $Id: SrcLoc.cc,v 1.2 1999/09/07 17:48:29 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xstd.h"

#include <iostream.h>

#include "SrcLoc.h"


SrcLoc::SrcLoc(const String &aFName, int aLineNo):
	theFName(aFName), theLineNo(aLineNo) {
}

bool SrcLoc::sameLine(const SrcLoc &t) const {
	return theFName && theFName == t.theFName && theLineNo == t.theLineNo;
}

ostream &SrcLoc::print(ostream &os) const {
	if (theFName)
		os << theFName << ':' << theLineNo << ": ";
	return os;
}
