
/*
 * $Id: IpSocket.h,v 1.1.2.3 1999/11/07 07:02:29 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef XSTD_IP_SOCKET_CLASS_H
#define XSTD_IP_SOCKET_CLASS_H

#include "Array.h"
#include "Socket.h"

struct ip_fw;
struct dn_pipe;

// this Socket type adds some basic IP-level operations to generic Socket
class IpSocket: public Socket {
	public:
		IpSocket() {}
		IpSocket(int aFD): Socket(aFD) {}

		bool create();

		/* ipfw */
		bool getIpFwRules(Array<ip_fw> &rules) const;
		bool addIpFwRule(const ip_fw &rule);
		bool delIpFwRule(const ip_fw &rule);
		bool delIpFwRules();

		/* dummynet */
		bool getDnPipes(Array<dn_pipe> &pipes) const;
		bool configureDnPipe(const dn_pipe &pipe);
		bool delDnPipe(const dn_pipe &pipe);
		bool delDnPipes();
};

#endif
