
/*
 * $Id: LibInit.h,v 1.4 1999/09/07 17:48:40 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef LIB_INIT_H
#define LIB_INIT_H


// declares a standard library initializer

#define LIB_INITIALIZER(Name)\
static \
class Name { \
	public: \
		Name() { if (!TheUseCount++) init(); } \
		~Name() { if (!--TheUseCount) clean(); } \
\
	protected: \
		void init(); \
		void clean(); \
\
	protected: \
		static int TheUseCount; \
} The ## Name;

#endif
