
/*
 * $Id: ResourceUsage.h,v 1.1.2.1 1999/11/08 04:29:31 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef XSTD_RESOURCE_USAGE_H
#define XSTD_RESOURCE_USAGE_H

#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>

#include "String.h"
#include "fixResourceUsage.h"

class ostream;

// a wrapper arround highly unportable "getrusage()" system call
class ResourceUsage: protected rusage {
	public:
		static ResourceUsage Current(); // current rusage

	public:
		ResourceUsage();

		Time sysTime() const;
		Time userTime() const;
		Time cpuTime() const;
		Size maxResSize() const;
		long physPageFaults() const;

		bool update(); // syncronize with current usage

		void report(ostream &os, const String &pfx = "") const;
};


inline
ostream &operator <<(ostream &os, const ResourceUsage &ru) {
	ru.report(os);
	return os;
}

#endif
